/* LED counter GNOME panel applet
 * Insprired by Sixtyfour bit counter by Tim Gerla
 * and xled by Jan Schoenepauck <schoenep@uni-wuppertal.de>
 * and Joachim Gassen <gassen@uni-muenster.de>"
 *
 * By Uwe Steinmann <Uwe.Steinmann@fernuni-hagen.de>
 *
 * Enjoy.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License  
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include <applet-widget.h>
#include "gimon.h"

#define BIG_ICON_SIZE   48

static GtkWidget *pb;

extern int updatetime;
extern gint timeout;
extern int popup_width;
extern int popup_height;
extern int count_timer(void);
extern char *none_in_filename;
extern char *none_out_filename;
extern char *modem_in_filename;
extern char *modem_out_filename;
extern char *net_in_filename;
extern char *net_out_filename;
extern char *raw_in_filename;
extern char *raw_out_filename;
extern char *voice_in_filename;
extern char *voice_out_filename;
extern char *fax_in_filename;
extern char *fax_out_filename;
extern GdkPixmap *none_in_pixmap;
extern GdkBitmap *none_in_pixmap_mask;
extern GdkPixmap *none_out_pixmap;
extern GdkBitmap *none_out_pixmap_mask;
extern GdkPixmap *modem_in_pixmap;
extern GdkBitmap *modem_in_pixmap_mask;
extern GdkPixmap *modem_out_pixmap;
extern GdkBitmap *modem_out_pixmap_mask;
extern GdkPixmap *net_in_pixmap;
extern GdkBitmap *net_in_pixmap_mask;
extern GdkPixmap *net_out_pixmap;
extern GdkBitmap *net_out_pixmap_mask;
extern GdkPixmap *raw_in_pixmap;
extern GdkBitmap *raw_in_pixmap_mask;
extern GdkPixmap *raw_out_pixmap;
extern GdkBitmap *raw_out_pixmap_mask;
extern GdkPixmap *voice_in_pixmap;
extern GdkBitmap *voice_in_pixmap_mask;
extern GdkPixmap *voice_out_pixmap;
extern GdkBitmap *voice_out_pixmap_mask;
extern GdkPixmap *fax_in_pixmap;
extern GdkBitmap *fax_in_pixmap_mask;
extern GdkPixmap *fax_out_pixmap;
extern GdkBitmap *fax_out_pixmap_mask;

void
loadup_file(GdkPixmap **pixmap, GdkBitmap **mask, char *file)
{
	GdkImlibImage *im = NULL;
	int w,h;

	if(!file) {
		*pixmap = NULL;
		*mask = NULL;
		return;
	}

	if(*file!='/') {
		char *f;
		f = gnome_pixmap_file (file);
		if(f) {
			im = gdk_imlib_load_image (f);
			g_free(f);
		}
	} else
		im = gdk_imlib_load_image (file);
	if(!im) {
		*pixmap = NULL;
		*mask = NULL;
		return;
	}

	w = im->rgb_width;
	h = im->rgb_height;
	if(w>h) {
		if(w>BIG_ICON_SIZE) {
			h = h*((double)BIG_ICON_SIZE/w);
			w = BIG_ICON_SIZE;
		}
	} else {
		if(h>BIG_ICON_SIZE) {
			w = w*((double)BIG_ICON_SIZE/h);
			h = BIG_ICON_SIZE;
		}
	}
	w = w>0?w:1;
	h = h>0?h:1;
	gdk_imlib_render (im, w, h);

	*pixmap = gdk_imlib_copy_image (im);
	*mask = gdk_imlib_copy_mask (im);

	gdk_imlib_destroy_image (im);
}

static void apply_cb(GtkObject *pb, gpointer p)
{
	char *buf;

	GtkWidget *width_s = gtk_object_get_data(GTK_OBJECT(pb),"width");
	GtkWidget *height_s = gtk_object_get_data(GTK_OBJECT(pb),"height");
	GtkWidget *update_s = gtk_object_get_data(GTK_OBJECT(pb), "update");
	GtkWidget *none_in_s = gtk_object_get_data(GTK_OBJECT(pb), "none_in");
	GtkWidget *none_out_s = gtk_object_get_data(GTK_OBJECT(pb), "none_out");
	GtkWidget *modem_in_s = gtk_object_get_data(GTK_OBJECT(pb), "modem_in");
	GtkWidget *modem_out_s = gtk_object_get_data(GTK_OBJECT(pb), "modem_out");
	GtkWidget *net_in_s = gtk_object_get_data(GTK_OBJECT(pb), "net_in");
	GtkWidget *net_out_s = gtk_object_get_data(GTK_OBJECT(pb), "net_out");
	GtkWidget *raw_in_s = gtk_object_get_data(GTK_OBJECT(pb), "raw_in");
	GtkWidget *raw_out_s = gtk_object_get_data(GTK_OBJECT(pb), "raw_out");
	GtkWidget *fax_in_s = gtk_object_get_data(GTK_OBJECT(pb), "fax_in");
	GtkWidget *fax_out_s = gtk_object_get_data(GTK_OBJECT(pb), "fax_out");
	GtkWidget *voice_in_s = gtk_object_get_data(GTK_OBJECT(pb), "voice_in");
	GtkWidget *voice_out_s = gtk_object_get_data(GTK_OBJECT(pb), "voice_out");

	buf = gtk_entry_get_text(GTK_ENTRY(height_s));
	sscanf(buf, "%d", &popup_height);
	buf = gtk_entry_get_text(GTK_ENTRY(width_s));
	sscanf(buf, "%d", &popup_width);
	buf = gtk_entry_get_text(GTK_ENTRY(update_s));
	sscanf(buf, "%d", &updatetime);
	gtk_timeout_remove(timeout);
	timeout = gtk_timeout_add(updatetime, (GtkFunction)count_timer, NULL);

	none_in_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(none_in_s));
	loadup_file(&none_in_pixmap, &none_in_pixmap_mask, none_in_filename);
	none_out_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(none_out_s));
	loadup_file(&modem_out_pixmap, &modem_out_pixmap_mask, modem_out_filename);

	modem_in_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(modem_in_s));
	loadup_file(&modem_in_pixmap, &modem_in_pixmap_mask, modem_in_filename);
	modem_out_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(modem_out_s));
	loadup_file(&modem_out_pixmap, &modem_out_pixmap_mask, modem_out_filename);

	net_in_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(net_in_s));
	loadup_file(&net_in_pixmap, &net_in_pixmap_mask, net_in_filename);
	net_out_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(net_out_s));
	loadup_file(&net_out_pixmap, &net_out_pixmap_mask, net_out_filename);

	raw_in_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(raw_in_s));
	loadup_file(&raw_in_pixmap, &raw_in_pixmap_mask, raw_in_filename);
	raw_out_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(raw_out_s));
	loadup_file(&raw_out_pixmap, &raw_out_pixmap_mask, raw_out_filename);

	fax_in_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(fax_in_s));
	loadup_file(&fax_in_pixmap, &fax_in_pixmap_mask, fax_in_filename);
	fax_out_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(fax_out_s));
	loadup_file(&fax_out_pixmap, &fax_out_pixmap_mask, fax_out_filename);

	voice_in_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(voice_in_s));
	loadup_file(&voice_in_pixmap, &voice_in_pixmap_mask, voice_in_filename);
	voice_out_filename = gnome_icon_entry_get_filename(GNOME_ICON_ENTRY(voice_out_s));
	loadup_file(&voice_out_pixmap, &voice_out_pixmap_mask, voice_out_filename);

}

static void
changed_cb(GtkWidget *w, GtkWidget *d)
{	
	gnome_property_box_changed(GNOME_PROPERTY_BOX(pb));
}

static void
create_icon_entry(GtkWidget *table,
          char *history_id,
          int row,
          char *label,
          char *text_in,
          char *text_out,
          GtkWidget *w,
          GtkWidget **entry1,
          GtkWidget **entry2)
{
	GtkWidget *wlabel;
	GtkWidget *t1, *t2;

	wlabel = gtk_label_new(label);
	gtk_misc_set_alignment(GTK_MISC(wlabel), 0.0, 0.5);
	gtk_table_attach(GTK_TABLE(table), wlabel,
	         0, 1, row, row + 1,
	         GTK_EXPAND | GTK_FILL | GTK_SHRINK,
	         GTK_FILL | GTK_SHRINK,
	         GNOME_PAD_SMALL, GNOME_PAD_SMALL);
	gtk_widget_show(wlabel);

	*entry1 = gnome_icon_entry_new(history_id,_("Browse"));
	if (text_in)
		gnome_icon_entry_set_icon(GNOME_ICON_ENTRY(*entry1),text_in);

	t1 = gnome_icon_entry_gtk_entry (GNOME_ICON_ENTRY (*entry1));
	gtk_table_attach(GTK_TABLE(table), *entry1,
	         1, 2, row, row + 1,
	         GTK_EXPAND | GTK_FILL | GTK_SHRINK,
	         GTK_FILL | GTK_SHRINK,
	         GNOME_PAD_SMALL, GNOME_PAD_SMALL);

	gtk_signal_connect_object(GTK_OBJECT (t1), "changed",
	                       GTK_SIGNAL_FUNC(changed_cb),
	                       NULL);

	*entry2 = gnome_icon_entry_new(history_id,_("Browse"));
	if (text_out)
		gnome_icon_entry_set_icon(GNOME_ICON_ENTRY(*entry2),text_out);

	t2 = gnome_icon_entry_gtk_entry (GNOME_ICON_ENTRY (*entry2));
	gtk_table_attach(GTK_TABLE(table), *entry2,
	         2, 3, row, row + 1,
	         GTK_EXPAND | GTK_FILL | GTK_SHRINK,
	         GTK_FILL | GTK_SHRINK,
	         GNOME_PAD_SMALL, GNOME_PAD_SMALL);

	gtk_signal_connect_object(GTK_OBJECT (t2), "changed",
	                       GTK_SIGNAL_FUNC(changed_cb),
	                       NULL);

}

void
prefs_cb(GtkWidget *w, gpointer p)
{
	GtkWidget *table;
	GtkWidget *frame, *hbox, *tbox, *label, *spin_label, *cadre;
	GtkAdjustment *adj;
	GtkWidget *entry1, *entry2;

	pb = gnome_property_box_new();
	gtk_window_set_title(GTK_WINDOW(pb), _("gimon Preferences"));
	
	frame=gtk_vbox_new(FALSE,5);

	table = gtk_table_new(8, 3, FALSE);
	gnome_property_box_append_page(GNOME_PROPERTY_BOX(pb), frame,
                       gtk_label_new(_("General")));
	
	hbox=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(frame),hbox,FALSE,FALSE,5);
	gtk_widget_show(hbox);
	label=gtk_label_new(_("Refresh rate (in milli seconds)"));
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,5);
	gtk_widget_show(label);
	adj=(GtkAdjustment *)gtk_adjustment_new(updatetime,100,200000,1000,100,10);
	spin_label=gtk_spin_button_new(adj,1,0);
	gtk_widget_set_usize(spin_label, 70,-1);
	gtk_object_set_data(GTK_OBJECT(pb), "update", spin_label);
	gtk_box_pack_start(GTK_BOX(hbox),spin_label,FALSE,FALSE,5);
	gtk_widget_show(spin_label);
	gtk_signal_connect_object(GTK_OBJECT(adj),"value_changed",GTK_SIGNAL_FUNC(changed_cb),NULL);
	gtk_signal_connect_object(GTK_OBJECT(spin_label),"changed",GTK_SIGNAL_FUNC(changed_cb),NULL);

	cadre=gtk_frame_new(_("Popup-window geometry"));
	gtk_widget_show(cadre);
	tbox=gtk_vbox_new(FALSE,5);
	gtk_widget_show(tbox);
	
	hbox=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(tbox),hbox,FALSE,FALSE,5);
	gtk_widget_show(hbox);
	label=gtk_label_new(_("Width"));
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,5);
	gtk_widget_show(label);
	adj=(GtkAdjustment *)gtk_adjustment_new(popup_width,100.0,1000.0,1,1,1);
	spin_label=gtk_spin_button_new(adj,1,0);
	gtk_object_set_data(GTK_OBJECT(pb), "width", spin_label);
	gtk_box_pack_start(GTK_BOX(hbox),spin_label,FALSE,FALSE,5);
	gtk_widget_show(spin_label);
	gtk_signal_connect_object(GTK_OBJECT(adj),"value_changed",GTK_SIGNAL_FUNC(changed_cb),NULL);
	gtk_signal_connect_object(GTK_OBJECT(spin_label),"changed",GTK_SIGNAL_FUNC(changed_cb),NULL);


	hbox=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(tbox),hbox,FALSE,FALSE,5);
	gtk_widget_show(hbox);
	label=gtk_label_new(_("Height"));
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,5);
	gtk_widget_show(label);
	adj=(GtkAdjustment *)gtk_adjustment_new(popup_height,50,1200.0,1,1,1);
	spin_label=gtk_spin_button_new(adj,1,0);
	gtk_object_set_data(GTK_OBJECT(pb), "height", spin_label);
	gtk_box_pack_start(GTK_BOX(hbox),spin_label,FALSE,FALSE,5);
	gtk_widget_show(spin_label);
	gtk_signal_connect_object(GTK_OBJECT(adj),"value_changed",GTK_SIGNAL_FUNC(changed_cb),NULL);
	gtk_signal_connect_object(GTK_OBJECT(spin_label),"changed",GTK_SIGNAL_FUNC(changed_cb),NULL);


	gtk_container_add(GTK_CONTAINER(cadre),tbox);
	gtk_box_pack_start(GTK_BOX(frame),cadre,FALSE,FALSE,15);
	
	gtk_widget_show(frame);

	table = gtk_table_new(8, 3, FALSE);
	gnome_property_box_append_page(GNOME_PROPERTY_BOX(pb), table,
                       gtk_label_new(_("Pixmaps")));

	label = gtk_label_new(_("Function"));
	gtk_table_attach(GTK_TABLE(table), label,
             0, 1, 0, 1,
             GTK_EXPAND | GTK_FILL | GTK_SHRINK,
             GTK_FILL | GTK_SHRINK,
             GNOME_PAD_SMALL, GNOME_PAD_SMALL);
	label = gtk_label_new(_("In"));
	gtk_table_attach(GTK_TABLE(table), label,
             1, 2, 0, 1,
             GTK_EXPAND | GTK_FILL | GTK_SHRINK,
             GTK_FILL | GTK_SHRINK,
             GNOME_PAD_SMALL, GNOME_PAD_SMALL);
	label = gtk_label_new(_("Out"));
	gtk_table_attach(GTK_TABLE(table), label,
             2, 3, 0, 1,
             GTK_EXPAND | GTK_FILL | GTK_SHRINK,
             GTK_FILL | GTK_SHRINK,
             GNOME_PAD_SMALL, GNOME_PAD_SMALL);

	create_icon_entry(table, "tile_file",1,
	                  _("No Connection"),
	                  none_in_filename,
	                  none_out_filename,
                    NULL,
	                  &entry1, &entry2);
	gtk_object_set_data(GTK_OBJECT(pb), "none_in", entry1);
	gtk_object_set_data(GTK_OBJECT(pb), "none_out", entry2);

	create_icon_entry(table, "tile_file",2,
	                  _("Modem"),
	                  modem_in_filename,
	                  modem_out_filename,
                    NULL,
	                  &entry1, &entry2);
	gtk_object_set_data(GTK_OBJECT(pb), "modem_in", entry1);
	gtk_object_set_data(GTK_OBJECT(pb), "modem_out", entry2);

	create_icon_entry(table, "tile_file",3,
	                  _("Network"),
	                  net_in_filename,
	                  net_out_filename,
                    NULL,
	                  &entry1, &entry2);
	gtk_object_set_data(GTK_OBJECT(pb), "net_in", entry1);
	gtk_object_set_data(GTK_OBJECT(pb), "net_out", entry2);

	create_icon_entry(table, "tile_file",4,
	                  _("Raw"),
	                  raw_in_filename,
	                  raw_out_filename,
                    NULL,
	                  &entry1, &entry2);
	gtk_object_set_data(GTK_OBJECT(pb), "raw_in", entry1);
	gtk_object_set_data(GTK_OBJECT(pb), "raw_out", entry2);

	create_icon_entry(table, "tile_file",5,
	                  _("Voice"),
	                  voice_in_filename,
	                  voice_out_filename,
                    NULL,
	                  &entry1, &entry2);
	gtk_object_set_data(GTK_OBJECT(pb), "voice_in", entry1);
	gtk_object_set_data(GTK_OBJECT(pb), "voice_out", entry2);

	create_icon_entry(table, "tile_file",6,
	                  _("Fax"),
	                  fax_in_filename,
	                  fax_out_filename,
                    NULL,
	                  &entry1, &entry2);
	gtk_object_set_data(GTK_OBJECT(pb), "fax_in", entry1);
	gtk_object_set_data(GTK_OBJECT(pb), "fax_out", entry2);

	gtk_widget_show(table);

	gtk_signal_connect(GTK_OBJECT(pb), "apply",
                           GTK_SIGNAL_FUNC(apply_cb), pb);
	gtk_signal_connect(GTK_OBJECT(pb), "destroy",
                           GTK_SIGNAL_FUNC(gtk_widget_destroyed),&pb);

	gtk_widget_show_all(pb);
}
